﻿// $Header: $ 
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

// ReSharper disable LocalizableElement
// ReSharper disable PossibleNullReferenceException
#region Example
// This example shows how to browse objects under the "Objects" node and display event sources.

using System;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace;
using OpcLabs.EasyOpc.UA.AddressSpace.Standard;
using OpcLabs.EasyOpc.UA.OperationModel;

namespace UADocExamples.AlarmsAndConditions
{
    class BrowseEventSources
    {
        public static void Overload2()
        {
            // Start browsing from the "Objects" node
            try
            {
                BrowseFrom(UAObjectIds.ObjectsFolder);
            }
            catch (UAException uaException)
            {
                Console.WriteLine("*** Failure: {0}", uaException.GetBaseException().Message);
            }
        }

        private static void BrowseFrom(UANodeDescriptor nodeDescriptor)
        {
            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("Parent node: {0}", nodeDescriptor);

            // Instantiate the client object
            var client = new EasyUAClient();

            // Obtain notifiers
            UANodeElementCollection eventSourceNodeElementCollection = client.BrowseEventSources(
                "opc.tcp://opcua.demo-this.com:62544/Quickstarts/AlarmConditionServer",
                nodeDescriptor);

            // Display notifiers
            Console.WriteLine();
            Console.WriteLine("Event sources:");
            foreach (UANodeElement eventSourceNodeElement in eventSourceNodeElementCollection)
                Console.WriteLine(eventSourceNodeElement);

            // Obtain objects
            UANodeElementCollection objectNodeElementCollection = client.BrowseObjects(
                "opc.tcp://opcua.demo-this.com:62544/Quickstarts/AlarmConditionServer",
                nodeDescriptor);

            // Recurse
            foreach (UANodeElement objectNodeElement in objectNodeElementCollection)
                BrowseFrom(objectNodeElement);
        }
    }
}
#endregion
